Loading...
Searching...
No Matches
juce::ReferenceCountedObjectPtr< ObjectType > Class Template Reference

## Detailed Description

template<class ObjectType>
class juce::ReferenceCountedObjectPtr< ObjectType >

A smart-pointer class which points to a reference-counted object.

The template parameter specifies the class of the object you want to point to - the easiest way to make a class reference-countable is to simply make it inherit from ReferenceCountedObject or SingleThreadedReferenceCountedObject, but if you need to, you can roll your own reference-countable class by implementing a set of methods called incReferenceCount(), decReferenceCount(), and decReferenceCountWithoutDeleting(). See ReferenceCountedObject for examples of how these methods should behave.

When using this class, you'll probably want to create a typedef to abbreviate the full templated name - e.g.

struct MyClass : public ReferenceCountedObject
{
using Ptr = ReferenceCountedObjectPtr<MyClass>;
...
}
juce::ReferenceCountedObjectPtr::ReferenceCountedObjectPtr
ReferenceCountedObjectPtr()=default
Creates a pointer to a null object.
juce::ReferenceCountedObject
A base class which provides methods for reference-counting.
Definition juce_ReferenceCountedObject.h:78

See also
  ReferenceCountedObject, ReferenceCountedObjectArray

The documentation for this class was generated from the following file:

- juce_core/memory/juce_ReferenceCountedObject.h

## Public Types

using | ReferencedType = ObjectType
| The class being referenced by this pointer.

## Public Member Functions

| ReferenceCountedObjectPtr ()=default
| Creates a pointer to a null object.
| ReferenceCountedObjectPtr (decltype(nullptr)) noexcept
| Creates a pointer to a null object.
| ReferenceCountedObjectPtr (ReferencedType *refCountedObject) noexcept
| Creates a pointer to an object.
| ReferenceCountedObjectPtr (ReferencedType &refCountedObject) noexcept
| Creates a pointer to an object.
| ReferenceCountedObjectPtr (const ReferenceCountedObjectPtr &other) noexcept
| Copies another pointer.
| ReferenceCountedObjectPtr (ReferenceCountedObjectPtr &&other) noexcept
| Takes-over the object from another pointer.
template<typename Convertible>
| ReferenceCountedObjectPtr (const ReferenceCountedObjectPtr< Convertible > &other) noexcept
| Copies another pointer.
ReferenceCountedObjectPtr & | operator= (const ReferenceCountedObjectPtr &other)
| Changes this pointer to point at a different object.
template<typename Convertible>
ReferenceCountedObjectPtr & | operator= (const ReferenceCountedObjectPtr< Convertible > &other)
| Changes this pointer to point at a different object.
ReferenceCountedObjectPtr & | operator= (ReferencedType *newObject)
| Changes this pointer to point at a different object.
ReferenceCountedObjectPtr & | operator= (ReferencedType &newObject)
| Changes this pointer to point at a different object.
ReferenceCountedObjectPtr & | operator= (decltype(nullptr))
| Resets this pointer to a null pointer.
ReferenceCountedObjectPtr & | operator= (ReferenceCountedObjectPtr &&other) noexcept
| Takes-over the object from another pointer.
| ~ReferenceCountedObjectPtr ()
| Destructor.
ReferencedType * | get () const noexcept
| Returns the object that this pointer references.
void | reset () noexcept
| Resets this object to a null pointer.
ReferencedType * | operator-> () const noexcept
ReferencedType & | operator* () const noexcept
| Dereferences the object that this pointer references.
bool | operator== (decltype(nullptr)) const noexcept
| Checks whether this pointer is null.
bool | operator!= (decltype(nullptr)) const noexcept
| Checks whether this pointer is null.
bool | operator== (const ObjectType *other) const noexcept
| Compares two ReferenceCountedObjectPtrs.
bool | operator== (const ReferenceCountedObjectPtr &other) const noexcept
| Compares two ReferenceCountedObjectPtrs.
bool | operator!= (const ObjectType *other) const noexcept
| Compares two ReferenceCountedObjectPtrs.
bool | operator!= (const ReferenceCountedObjectPtr &other) const noexcept
| Compares two ReferenceCountedObjectPtrs.
| operator ReferencedType * () const noexcept
| Returns the object that this pointer references.

## Member Typedef Documentation

## ReferencedType

template<class ObjectType>

using juce::ReferenceCountedObjectPtr< ObjectType >::ReferencedType = ObjectType

The class being referenced by this pointer.

## Constructors and Destructors

## ReferenceCountedObjectPtr() [1/7]

template<class ObjectType>

juce::ReferenceCountedObjectPtr< ObjectType >::ReferenceCountedObjectPtr | ( |  | ) |

default

Creates a pointer to a null object.

## ReferenceCountedObjectPtr() [2/7]

template<class ObjectType>

juce::ReferenceCountedObjectPtr< ObjectType >::ReferenceCountedObjectPtr | ( | decltype(nullptr) |  | ) |

inline noexcept

Creates a pointer to a null object.

## ReferenceCountedObjectPtr() [3/7]

template<class ObjectType>

juce::ReferenceCountedObjectPtr< ObjectType >::ReferenceCountedObjectPtr | ( | ReferencedType * | refCountedObject | ) |

inline noexcept

Creates a pointer to an object.

This will increment the object's reference-count.

## ReferenceCountedObjectPtr() [4/7]

template<class ObjectType>

juce::ReferenceCountedObjectPtr< ObjectType >::ReferenceCountedObjectPtr | ( | ReferencedType & | refCountedObject | ) |

inline noexcept

Creates a pointer to an object.

This will increment the object's reference-count.

## ReferenceCountedObjectPtr() [5/7]

template<class ObjectType>

juce::ReferenceCountedObjectPtr< ObjectType >::ReferenceCountedObjectPtr | ( | const ReferenceCountedObjectPtr< ObjectType > & | other | ) |

inline noexcept

Copies another pointer.

This will increment the object's reference-count.

## ReferenceCountedObjectPtr() [6/7]

template<class ObjectType>

juce::ReferenceCountedObjectPtr< ObjectType >::ReferenceCountedObjectPtr | ( | ReferenceCountedObjectPtr< ObjectType > && | other | ) |

inline noexcept

Takes-over the object from another pointer.

## ReferenceCountedObjectPtr() [7/7]

template<class ObjectType>
template<typename Convertible>

juce::ReferenceCountedObjectPtr< ObjectType >::ReferenceCountedObjectPtr | ( | const ReferenceCountedObjectPtr< Convertible > & | other | ) |

inline noexcept

Copies another pointer.

This will increment the object's reference-count (if it is non-null).

## ~ReferenceCountedObjectPtr()

template<class ObjectType>

juce::ReferenceCountedObjectPtr< ObjectType >::~ReferenceCountedObjectPtr | ( |  | ) |

inline

Destructor.

This will decrement the object's reference-count, which will cause the object to be deleted when the ref-count hits zero.

## Member Functions

## operator=() [1/6]

template<class ObjectType>

ReferenceCountedObjectPtr & juce::ReferenceCountedObjectPtr< ObjectType >::operator= | ( | const ReferenceCountedObjectPtr< ObjectType > & | other | ) |

inline

Changes this pointer to point at a different object.

The reference count of the old object is decremented, and it might be deleted if it hits zero. The new object's count is incremented.

Referenced by juce::ReferenceCountedObjectPtr< SynthesiserSound >::operator=(), juce::ReferenceCountedObjectPtr< SynthesiserSound >::operator=(), and juce::ReferenceCountedObjectPtr< SynthesiserSound >::operator=().

## operator=() [2/6]

template<class ObjectType>
template<typename Convertible>

ReferenceCountedObjectPtr & juce::ReferenceCountedObjectPtr< ObjectType >::operator= | ( | const ReferenceCountedObjectPtr< Convertible > & | other | ) |

inline

Changes this pointer to point at a different object.

The reference count of the old object is decremented, and it might be deleted if it hits zero. The new object's count is incremented.

## operator=() [3/6]

template<class ObjectType>

ReferenceCountedObjectPtr & juce::ReferenceCountedObjectPtr< ObjectType >::operator= | ( | ReferencedType * | newObject | ) |

inline

Changes this pointer to point at a different object.

The reference count of the old object is decremented, and it might be deleted if it hits zero. The new object's count is incremented.

## operator=() [4/6]

template<class ObjectType>

ReferenceCountedObjectPtr & juce::ReferenceCountedObjectPtr< ObjectType >::operator= | ( | ReferencedType & | newObject | ) |

inline

Changes this pointer to point at a different object.

The reference count of the old object is decremented, and it might be deleted if it hits zero. The new object's count is incremented.

## operator=() [5/6]

template<class ObjectType>

ReferenceCountedObjectPtr & juce::ReferenceCountedObjectPtr< ObjectType >::operator= | ( | decltype(nullptr) |  | ) |

inline

Resets this pointer to a null pointer.

## operator=() [6/6]

template<class ObjectType>

ReferenceCountedObjectPtr & juce::ReferenceCountedObjectPtr< ObjectType >::operator= | ( | ReferenceCountedObjectPtr< ObjectType > && | other | ) |

inline noexcept

Takes-over the object from another pointer.

## get()

template<class ObjectType>

ReferencedType * juce::ReferenceCountedObjectPtr< ObjectType >::get | ( |  | ) | const

inline noexcept

Returns the object that this pointer references.

The pointer returned may be null, of course.

Referenced by juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::add(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::addIfNotAlreadyThere(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::insert(), juce::ReferenceCountedObjectPtr< SynthesiserSound >::operator=(), juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::removeObject(), and juce::ReferenceCountedArray< ObjectClass, TypeOfCriticalSectionToUse >::set().

## reset()

template<class ObjectType>

void juce::ReferenceCountedObjectPtr< ObjectType >::reset | ( |  | ) |

inline noexcept

Resets this object to a null pointer.

Referenced by juce::ReferenceCountedObjectPtr< SynthesiserSound >::operator=(), and juce::ReferenceCountedObjectPtr< SynthesiserSound >::operator=().

## operator->()

template<class ObjectType>

ReferencedType * juce::ReferenceCountedObjectPtr< ObjectType >::operator-> | ( |  | ) | const

inline noexcept

## operator*()

template<class ObjectType>

ReferencedType & juce::ReferenceCountedObjectPtr< ObjectType >::operator* | ( |  | ) | const

inline noexcept

Dereferences the object that this pointer references.

The pointer returned may be null, of course.

## operator==() [1/3]

template<class ObjectType>

bool juce::ReferenceCountedObjectPtr< ObjectType >::operator== | ( | decltype(nullptr) |  | ) | const

inline noexcept

Checks whether this pointer is null.

## operator!=() [1/3]

template<class ObjectType>

bool juce::ReferenceCountedObjectPtr< ObjectType >::operator!= | ( | decltype(nullptr) |  | ) | const

inline noexcept

Checks whether this pointer is null.

## operator==() [2/3]

template<class ObjectType>

bool juce::ReferenceCountedObjectPtr< ObjectType >::operator== | ( | const ObjectType * | other | ) | const

inline noexcept

Compares two ReferenceCountedObjectPtrs.

## operator==() [3/3]

template<class ObjectType>

bool juce::ReferenceCountedObjectPtr< ObjectType >::operator== | ( | const ReferenceCountedObjectPtr< ObjectType > & | other | ) | const

inline noexcept

Compares two ReferenceCountedObjectPtrs.

## operator!=() [2/3]

template<class ObjectType>

bool juce::ReferenceCountedObjectPtr< ObjectType >::operator!= | ( | const ObjectType * | other | ) | const

inline noexcept

Compares two ReferenceCountedObjectPtrs.

## operator!=() [3/3]

template<class ObjectType>

bool juce::ReferenceCountedObjectPtr< ObjectType >::operator!= | ( | const ReferenceCountedObjectPtr< ObjectType > & | other | ) | const

inline noexcept

Compares two ReferenceCountedObjectPtrs.

## operator ReferencedType *()

template<class ObjectType>

juce::ReferenceCountedObjectPtr< ObjectType >::operator ReferencedType * | ( |  | ) | const

inline noexcept

Returns the object that this pointer references.

The pointer returned may be null, of course. Note that this methods allows the compiler to be very lenient with what it allows you to do with the pointer, it's safer to disable this by setting JUCE_STRICT_REFCOUNTEDPOINTER=1, which increased type safety and can prevent some common slip-ups.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited